it-roy-ru.com

Maven - для артефакта версия не может быть пустой

Проблема: Я использую Maven и неожиданно получил несколько ошибок: 

For artifact {org.springframework.boot:spring-boot-starter-data-jpa:null:jar}: The version cannot be empty. (org.Apache.maven.plugins:maven-resources-plugin:2.6:resources:default-resources:process-resources)

org.Apache.maven.artifact.InvalidArtifactRTException: For artifact {org.springframework.boot:spring-boot-starter-data-jpa:null:jar}: The version cannot be empty.
    at org.Apache.maven.artifact.DefaultArtifact.validateIdentity(DefaultArtifact.Java:148)
    at org.Apache.maven.artifact.DefaultArtifact.<init>(DefaultArtifact.Java:123)
    at org.Apache.maven.artifact.factory.DefaultArtifactFactory.createArtifact(DefaultArtifactFactory.Java:157)
    at org.Apache.maven.artifact.factory.DefaultArtifactFactory.createDependencyArtifact(DefaultArtifactFactory.Java:57)
    at org.Apache.maven.project.artifact.MavenMetadataSource.createDependencyArtifact(MavenMetadataSource.Java:328)
    at org.Apache.maven.project.artifact.MavenMetadataSource.createArtifacts(MavenMetadataSource.Java:503)
    at org.Apache.maven.lifecycle.internal.DefaultProjectArtifactFactory.createArtifacts(DefaultProjectArtifactFactory.Java:50)
    at org.Apache.maven.lifecycle.internal.LifecycleDependencyResolver.resolveProjectDependencies(LifecycleDependencyResolver.Java:119)
    at org.Apache.maven.lifecycle.internal.MojoExecutor.ensureDependenciesAreResolved(MojoExecutor.Java:245)
    at org.Eclipse.m2e.core.internal.embedder.MavenImpl.execute(MavenImpl.Java:330)
    at org.Eclipse.m2e.core.internal.embedder.MavenImpl$11.call(MavenImpl.Java:1362)
    at org.Eclipse.m2e.core.internal.embedder.MavenImpl$11.call(MavenImpl.Java:1)
    at org.Eclipse.m2e.core.internal.embedder.MavenExecutionContext.executeBare(MavenExecutionContext.Java:176)
    at org.Eclipse.m2e.core.internal.embedder.MavenExecutionContext.execute(MavenExecutionContext.Java:112)
    at org.Eclipse.m2e.core.internal.embedder.MavenImpl.execute(MavenImpl.Java:1360)
    at org.Eclipse.m2e.core.project.configurator.MojoExecutionBuildParticipant.build(MojoExecutionBuildParticipant.Java:52)
    at org.Eclipse.m2e.core.internal.builder.MavenBuilderImpl.build(MavenBuilderImpl.Java:137)
    at org.Eclipse.m2e.core.internal.builder.MavenBuilder$1.method(MavenBuilder.Java:172)
    at org.Eclipse.m2e.core.internal.builder.MavenBuilder$1.method(MavenBuilder.Java:1)
    at org.Eclipse.m2e.core.internal.builder.MavenBuilder$BuildMethod$1$1.call(MavenBuilder.Java:115)
    at org.Eclipse.m2e.core.internal.embedder.MavenExecutionContext.executeBare(MavenExecutionContext.Java:176)
    at org.Eclipse.m2e.core.internal.embedder.MavenExecutionContext.execute(MavenExecutionContext.Java:112)
    at org.Eclipse.m2e.core.internal.builder.MavenBuilder$BuildMethod$1.call(MavenBuilder.Java:105)
    at org.Eclipse.m2e.core.internal.embedder.MavenExecutionContext.executeBare(MavenExecutionContext.Java:176)
    at org.Eclipse.m2e.core.internal.embedder.MavenExecutionContext.execute(MavenExecutionContext.Java:151)
    at org.Eclipse.m2e.core.internal.embedder.MavenExecutionContext.execute(MavenExecutionContext.Java:99)
    at org.Eclipse.m2e.core.internal.builder.MavenBuilder$BuildMethod.execute(MavenBuilder.Java:86)
    at org.Eclipse.m2e.core.internal.builder.MavenBuilder.build(MavenBuilder.Java:200)
    at org.Eclipse.core.internal.events.BuildManager$2.run(BuildManager.Java:735)
    at org.Eclipse.core.runtime.SafeRunner.run(SafeRunner.Java:42)
    at org.Eclipse.core.internal.events.BuildManager.basicBuild(BuildManager.Java:206)
    at org.Eclipse.core.internal.events.BuildManager.basicBuild(BuildManager.Java:246)
    at org.Eclipse.core.internal.events.BuildManager$1.run(BuildManager.Java:301)
    at org.Eclipse.core.runtime.SafeRunner.run(SafeRunner.Java:42)
    at org.Eclipse.core.internal.events.BuildManager.basicBuild(BuildManager.Java:304)
    at org.Eclipse.core.internal.events.BuildManager.basicBuildLoop(BuildManager.Java:360)
    at org.Eclipse.core.internal.events.BuildManager.build(BuildManager.Java:383)
    at org.Eclipse.core.internal.events.AutoBuildJob.doBuild(AutoBuildJob.Java:144)
    at org.Eclipse.core.internal.events.AutoBuildJob.run(AutoBuildJob.Java:235)
    at org.Eclipse.core.internal.jobs.Worker.run(Worker.Java:55)

Поэтому я добавил версию артефакта <version>1.3.5.RELEASE</version> в spring-boot-starter-data-jpa. К сожалению, я все еще получаю ту же проблему. Я даже почистил кеш мавена. Проект maven -> update не помог и project -> clean не помог 

Вопрос: Что еще я мог сделать не так?

pom.xml

<project xmlns="http://maven.Apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
    xsi:schemaLocation="http://maven.Apache.org/POM/4.0.0 http://maven.Apache.org/xsd/maven-4.0.0.xsd">
    <modelVersion>4.0.0</modelVersion>
    <groupId>SpringDataDemo</groupId>
    <artifactId>SpringDataDemo</artifactId>
    <version>0.0.1-SNAPSHOT</version>
    <packaging>war</packaging>

    <build>
        <plugins>
            <plugin>
                <groupId>org.springframework.boot</groupId>
                <artifactId>spring-boot-maven-plugin</artifactId>
            </plugin>
            <plugin>
                <artifactId>maven-compiler-plugin</artifactId>
                <version>3.5.1</version>
                <configuration>
                    <source>1.8</source>
                    <target>1.8</target>
                </configuration>
            </plugin>
            <plugin>
                <artifactId>maven-war-plugin</artifactId>
                <version>2.6</version>
                <configuration>
                    <warSourceDirectory>WebContent</warSourceDirectory>
                    <failOnMissingWebXml>false</failOnMissingWebXml>
                </configuration>
            </plugin>
        </plugins>
    </build>

    <repositories>
        <repository>
            <id>spring-releases</id>
            <name>Spring Releases</name>
            <url>https://repo.spring.io/libs-release</url>
        </repository>
        <repository>
            <id>org.jboss.repository.releases</id>
            <name>JBoss Maven Release Repository</name>
            <url>https://repository.jboss.org/nexus/content/repositories/releases</url>
        </repository>
    </repositories>

    <pluginRepositories>
        <pluginRepository>
            <id>spring-releases</id>
            <name>Spring Releases</name>
            <url>https://repo.spring.io/libs-release</url>
        </pluginRepository>
    </pluginRepositories>

    <properties>
        <Java.version>1.8</Java.version>
    </properties>

    <dependencies>
        <dependency>
            <groupId>org.springframework.boot</groupId>
            <artifactId>spring-boot-starter-data-jpa</artifactId>
            <version>1.3.5.RELEASE</version>
        </dependency>
        <dependency>
            <groupId>com.h2database</groupId>
            <artifactId>h2</artifactId>
            <version>1.4.192</version>
        </dependency>

    </dependencies>


</project>

Затмение помечает странные линии красным цветом, если это действительно проблема с номерами версий: 

 enter image description here

 enter image description here

4
jublikon

Вам нужно наследовать от родительского POM Spring Boot:

<parent>
    <groupId>org.springframework.boot</groupId>
    <artifactId>spring-boot-starter-parent</artifactId>
    <version>1.3.5.RELEASE</version>
</parent>

Этот родительский POM объявляет множество версий зависимостей для артефактов, которые вы можете использовать в своих проектах, поэтому вам не нужно указывать его самостоятельно.

Из документов :

Каждый выпуск Spring Boot предоставляет кураторский список зависимостей it поддерживает. На практике вам не нужно предоставлять версию для любого из эти зависимости в вашей конфигурации сборки, как Spring Boot справиться с этим для вас. При обновлении самой Spring Boot эти зависимости будут также обновлены в согласованном порядке.

Смотрите также:

14
Xtreme Biker

Версия отсутствует в следующем объявлении плагина:

        <plugin>
            <groupId>org.springframework.boot</groupId>
            <artifactId>spring-boot-maven-plugin</artifactId>
        </plugin>

Просто добавьте версию:

        <plugin>
            <groupId>org.springframework.boot</groupId>
            <artifactId>spring-boot-maven-plugin</artifactId>
            <version>1.3.5.RELEASE</version>
        </plugin>
0
ernest_k